<template>
  <v-container
    fill-height
    fluid
    grid-list-xl>
    <v-layout
      justify-center
      wrap
    >
      <v-data-table
        :headers="headers"
        :items="results"
        :items-per-page="10"
        class="elevation-1"
      ></v-data-table>
    </v-layout>
  </v-container>
</template>

<script>
import api from '@/api'

export default {
  name: "TestResults",
  data() {
    return {
      headers: [
        {
          text: 'Тест',
          align: 'start',
          value: 'name',
        },
        { text: 'Группа', value: 'group' },
        { text: 'Ученик', value: 'studentName' },
        { text: 'Баллов', sortable: false, value: 'points' },
        { text: 'Максимум', sortable: false, value: 'maxPoints' },
        { text: 'Завершен', sortable: false, value: 'end' },
      ],
      results: []
    }
  },
  async created() {
    await this.getResults();
  },
  methods: {
    getTime(timeString) {
      const date = new Date(timeString);
      return  date.toLocaleTimeString()
          + ' / ' + date.toLocaleDateString();
    },
    async getResults() {
      const res = await api.teacher.getResults({
        testId: this.$route.params.id
      });
      const results = res.answer;

      results.forEach(result => {
        result.end = result.finished
        ? this.getTime(result.updatedAt)
        : 'Не завершен';
        result.name = result.test.name;
        result.maxPoints = result.test.maxPoints;
        result.studentName = result.student.name;
        result.group = result.student.group;
      });
      
      this.results = results;
    }
  }
}
</script>